Subject: Re: [PATCH] ath11k: add register read debugfs interface for WCN6855

From: Kalle Valo <[email-masked]>
Date: Sat, 23 Apr 2022 13:32:57 +0300

Kalle Valo <[email-masked]> writes:

> Cheng Wang <[email-masked]> writes:
>
>> Add debugfs interface reg_addr/reg_value and use these two interfaces
>> to read register value.
>> For example, execute the following commands to read WCN6855 HW register of
>> “memtype=0xa offset=0x3a00d0”:
>>
>> $ echo 0xa 0x3a00d0>reg_addr
>> $ cat reg_value
>> 0x10200000
>>
>> Tested-on: WCN6855 hw2.0 PCI WLAN.HSP.1.1-01720.1-QCAHSPSWPL_V1_V2_SILICONZ_LITE-1
>>
>> Signed-off-by: Cheng Wang <[email-masked]>
>
> This had new warnings, fixed in the pending branch:
>
> drivers/net/wireless/ath/ath11k/debugfs.c:1207: line length of 96 exceeds 90 columns
> drivers/net/wireless/ath/ath11k/debugfs.c:1253: line length of 94 exceeds 90 columns
> drivers/net/wireless/ath/ath11k/debugfs.c:1318: line length of 91 exceeds 90 columns
> drivers/net/wireless/ath/ath11k/qmi.c:1673: line length of 94 exceeds 90 columns

I tried to test this[1] and I couldn't get it to work:

# echo 0xa 0x3a00d0>reg_addr
# cat reg_value 
failed to read reg, err=-22

The error message from ath11k is:

[  923.629220] ath11k_pci 0000:06:00.0: ath11k_qmi_wlanfw_athdiag_read_send start, mem_type 10 offset 0x300000
[  923.647156] ath11k_pci 0000:06:00.0: QMI request failed result=0, error=0, valid=1, len=0

While reviewing the patch I found other issues:

o do not use ath11k_info()

o debug messages don't follow ath11k style

o warning messages don't follow ath11k style

o convert ab->hw_reg to struct ath11k_hw_params flag

o don't print a warning if register read feature is not supported

My setup on my NUC is:

[  679.283156] ath11k_pci 0000:06:00.0: MSI vectors: 32
[  679.283230] ath11k_pci 0000:06:00.0: wcn6855 hw2.0
[  679.486183] mhi mhi0: Requested to power ON
[  679.488864] mhi mhi0: Power on setup success
[  679.890486] mhi mhi0: Wait for device to enter SBL or Mission mode
[  680.537360] ath11k_pci 0000:06:00.0: chip_id 0x2 chip_family 0xb board_id 0x106 soc_id 0x400c0200
[  680.537669] ath11k_pci 0000:06:00.0: fw_version 0x110f0c35 fw_build_timestamp 2022-03-30 09:05 fw_build_id WLAN.HSP.1.1-03125-QCAHSPSWPL_V1_V2_SILICONZ_LITE-3.6510.7

[1] https://git.kernel.org/pub/scm/linux/kernel/git/kvalo/ath.git/commit/?h=pending&id=26c7a6e468f27c1155fd7e7cc8653eabe44b9640

-- 
https://patchwork.kernel.org/project/linux-wireless/list/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches